\defgroup Core Core ROOT classes
\brief The Core classes of ROOT.
\defgroup Base Base ROOT classes
\ingroup Core
\brief The Base classes of ROOT.

The base classes of the ROOT system provide the core of the system. They
are available to all other classes. They range from a set of abstract
interfaces (TVirtualXXXXX classes), to a wide range of basic utility
classes providing basic services like strings, regular expression,
timers, date/time, md5 checksumming, signal/slots event handling,
plugin handler, run-config resource processor, etc. etc.

\defgroup StdExt std Extension classes
\brief Extension classes within libCore to backport or complement missing std:: features

\defgroup Parallelism Parallelized classes
\brief Classes implement parallelism within ROOT